package _VisualDVM.Passes.All;
import Common.Passes.Pass;
import Common.Passes.PassException;
import _VisualDVM.Current;
import _VisualDVM.Global;
import _VisualDVM.GlobalData.RemoteFile.RemoteFile;
import _VisualDVM.GlobalData.User.UserState;
import _VisualDVM.Passes.PassCode;
import _VisualDVM.Repository.SubscriberWorkspace.SubscriberWorkspace;
public class InitialiseUser extends Pass {
    @Override
    public String getIconPath() {
        return "/icons/InitializeUser.png";
    }
    @Override
    public String getButtonText() {
        return "";
    }
    @Override
    protected boolean canStart(Object... args) throws Exception {
        return Global.mainModule.Check(Log, Current.Machine, Current.User);
    }
    @Override
    protected void body() throws Exception {
        switch (Global.mainModule.getMachine().type) {
            case Local:
                Global.mainModule.getPass(PassCode.LocalInitaliseUser).Do();
                break;
            case Server:
            case MVS_cluster:
                if (Global.mainModule.getPass(PassCode.CheckRemoteWorkspace).Do()) {
                    SubscriberWorkspace workspace = (SubscriberWorkspace) Global.mainModule.getPass(PassCode.CheckRemoteWorkspace).target;
                    if (workspace == null) {
                        if (Global.mainModule.getPass(PassCode.RemoteInitialiseUser).Do()) {
                            workspace = new SubscriberWorkspace();
                            workspace.email = Global.mainModule.getAccount().email;
                            workspace.URL = Global.mainModule.getMachine().getURL();
                            workspace.login = Global.mainModule.getUser().login;
                            workspace.path = ((RemoteFile) Global.mainModule.getPass(PassCode.RemoteInitialiseUser).target).full_name;
                            //---
                            if (Global.mainModule.getPass(PassCode.PublishRemoteWorkspace).Do(workspace)) {
                                Global.mainModule.getUser().workspace = workspace.path;
                                Global.mainModule.getUser().state = UserState.ready_to_work;
                                Global.mainModule.getDb().Update(Global.mainModule.getUser());
                            }
                        }
                    } else {
                        //рега была. просто заносим то что там пользователю
                        Global.mainModule.getUser().workspace = workspace.path;
                        Global.mainModule.getUser().state = UserState.ready_to_work;
                        Global.mainModule.getDb().Update(Global.mainModule.getUser());
                    }
                }
                break;
            default:
                throw new PassException("Неопределенный тип пользователя");
        }
    }
    @Override
    protected void showFinish() throws Exception {
        Global.mainModule.getDb().users.RefreshUI();
    }
}
